#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include "funct_codes.h"
#define MACSZ 14
#define PROTSZ 6
#define MAX_DATA_SZ 8994
#define DATA_INC 1
#define NWRTFF 13
#define NRDFF 20

enum etypes {FF_NO_ERR = 0, FF_RD_ERR = 1, FF_MT_ERR = 2, FF_RT_ERR = 4, FF_MK_ERR = 8, FF_WRT_ERR = 16, TC_NO_DATA = 32, TC_NOT_EXC = 64, TC_UNK_FNC = 96, TC_START_UP = 192, TC_RLD_PNDG = 224} err_type;


extern char wbuf[];
extern int nwbuf;
extern char rbuf[];
extern int nrbuf;


int flash_cmds(int nwrds)
{
  int n,l,lcnt;
  wbuf[0]=0x20;
  wbuf[1]=Flash_R_W;
  nwbuf=2*nwrds+2;
  //  for(l=0;l<nwbuf;l++){
  //    printf("%02X",wbuf[l]&0xFF);
  //  }
  //  printf("\n");
  n=eth_write();
  for(l=0;l<8000;l++)lcnt++;
  return(n);
}
int vme_cmds(int nwrds)
{
  int n,l,lcnt;
  wbuf[0]=0x20;
  wbuf[1]=VME_Cmds;
  nwbuf=2*nwrds+2;
  n=eth_write();
  for(l=0;l<8000;l++)lcnt++;
  return(n);
}

int wrt_ff(int nwrds)
{
  int n,l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=Wrt_Ext_FF;
  nwbuf=2*nwrds+2;
  n=eth_write();
  for(l=0;l<8000;l++)lcnt++;
  return(n);
}


int rd_ff(int nwrds,int prt_flg, int retrans)
{
  int i,n,numwrds;
  unsigned int x;
  char type;
  wbuf[0]=0x00;
  wbuf[1]=(retrans==1)?RT_Ext_FF:Rd_Ext_FF;
  wbuf[2]=(nwrds>>24)&0XFF;
  wbuf[3]=(nwrds>>16)&0XFF;
  wbuf[4]=(nwrds>>8)&0XFF;
  wbuf[5]=nwrds&0XFF;
  nwbuf=6;
  n=eth_write();
  n=eth_read();
  //  printf("read %d words\n",n);
  if(prt_flg==1){
    for(i=0;i<n;i++){
      printf("%02x",rbuf[i]&0xFF);
    }
    printf("\n");
  }
  type = rbuf[15]&0xff;
  if(type==0xF){
    err_type = rbuf[23]&0xFF;
  }
  else {
    err_type = FF_NO_ERR;
  }
  numwrds = ((rbuf[20]&0xff)<<8)|(rbuf[21]&0xff);
  for(i=0;i<numwrds;i++){
    x=((rbuf[2*i+22]&0xFF)<<8)|(rbuf[2*i+23]&0xFF);
    if(type==0xF){
      printf("read error %5d\n",x);
    }
    else {
      if(prt_flg==1)printf("%5d\n",x);
    }
  }
  if(numwrds<nwrds && !((type == 0xf) && (err_type == FF_MT_ERR))){
    n=eth_read();
    type = rbuf[15]&0xff;
    if(prt_flg==1){
      for(i=0;i<n;i++){
        printf("%02x",rbuf[i]&0xFF);
      }
      printf("\n");
    }
    x=((rbuf[22]&0xFF)<<8)|(rbuf[23]&0xFF);
    if(type==0xF){
      printf("read error %5d\n",x);
    }
    else {
      if(prt_flg==1)printf("%5d\n",x);
    }
  }
  return(n);
}

void prst_ff()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=PRst_Ext_FF;
  nwbuf=2;
  n=eth_write();
  printf("Partial reset of FIFO done.\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}

void mrst_ff()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=MRst_Ext_FF;
  nwbuf=2;
  n=eth_write();
  printf("Full reset of FIFO done.\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}

void set_mark()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=ST_MK_Ext_FF;
  nwbuf=2;
  n=eth_write();
  printf("Mark set at current read pointer.\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}

void rst_mark()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=RST_MK_Ext_FF;
  nwbuf=2;
  n=eth_write();
  printf("Reset mark -- Back to normal mode.\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}

void set_ff_test_mode()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=Set_FF_Test;
  nwbuf=2;
  n=eth_write();
  printf("Controller is in FIFO test mode.\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}

void set_VME_mode()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=Set_FF_VME;
  nwbuf=2;
  n=eth_write();
  printf("Controller is in VME mode.\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}

void enable_ECC()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=ECC_enable;
  nwbuf=2;
  n=eth_write();
  printf("Error Correcting Code is enabled.\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}
void disable_ECC()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=ECC_disable;
  nwbuf=2;
  n=eth_write();
  printf("Error Correcting Code is disabled.\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}

void rst_err_cnt()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=Rst_Ext_Err_Cnt;
  nwbuf=2;
  n=eth_write();
  printf("Reset error counters.\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}
void enable_inj_errs()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=Set_Inj_Err;
  nwbuf=2;
  n=eth_write();
  printf("Set inject error mode.\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}
void disable_inj_errs()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=Rst_Inj_Err;
  nwbuf=2;
  n=eth_write();
  printf("Error injecting is disabled.\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}

void enable_warn_on_shutdown()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=Warn_On_Shdwn;
  nwbuf=2;
  n=eth_write();
  printf("Shutdown warnings will be transmitted.\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}
void disable_warn_on_shutdown()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=No_Warn_On_Shdwn;
  nwbuf=2;
  n=eth_write();
  printf("Warnings of pending shutdowns are being disabled!\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}

void snd_startup_pkt()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=Snd_Startup_Pkt;
  nwbuf=2;
  n=eth_write();
  printf("An Info packet will be sent on start-up.\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}
void no_startup_pkt()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=No_Startup_Pkt;
  nwbuf=2;
  n=eth_write();
  printf("Disabling Info packet on start-up\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}
void force_reload()
{
  int n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=Force_Reload;
  nwbuf=2;
  n=eth_write();
  printf("Forcing Reload!\n");
  for(l=0;l<8000;l++)lcnt++;
  return;
}

void rd_err_cnts()
{
  int n;
  int l,lcnt,cor,uncor;
  wbuf[0]=0x60;
  wbuf[1]=Rd_Ext_Err_Cnts;
  nwbuf=2;
  n=eth_write();
  n=eth_read();
  //  printf("read %d words\n",n);
  printf("  Uncorrected   Corrected\n     Errors      Errors\n");
  printf("    %02x%02x%02x%02x    %02x%02x%02x%02x\n",rbuf[22]&0xFF,rbuf[23]&0xFF,rbuf[24]&0xFF,rbuf[25]&0xFF,rbuf[26]&0xFF,rbuf[27]&0xFF,rbuf[28]&0xFF,rbuf[29]&0xFF);
  uncor = 0;
  cor = 0;
  uncor = uncor | ((rbuf[22]&0xff)<<24)|((rbuf[23]&0xff)<<16)|((rbuf[24]&0xff)<<8)|(rbuf[25]&0xff);
  cor = cor | ((rbuf[26]&0xff)<<24)|((rbuf[27]&0xff)<<16)|((rbuf[28]&0xff)<<8)|(rbuf[29]&0xff);
  printf("    %8d    %8d\n\n",uncor,cor);
  return;
}




int prg_off(unsigned int full_off, unsigned int mt_off)
{
  int i,n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=Prg_Ext_Off;
  nwbuf=10;
  wbuf[2]=(full_off>>24)&0xff;
  wbuf[3]=(full_off>>16)&0xff;
  wbuf[4]=(full_off>>8)&0xff;
  wbuf[5]=(full_off)&0xff;
  wbuf[6]=(mt_off>>24)&0xff;
  wbuf[7]=(mt_off>>16)&0xff;
  wbuf[8]=(mt_off>>8)&0xff;
  wbuf[9]=(mt_off)&0xff;
  n=eth_write();
  printf("Offsets programmed\n");
  for(l=0;l<8000;l++)lcnt++;
  return(n);
}


int rdbk_off()
{
  unsigned int full_off, mt_off;
  int i,n;
  int l,lcnt;
  wbuf[0]=0x00;
  wbuf[1]=Rdbk_Ext_Off;
  nwbuf=2 ;
  n=eth_write();
  n=eth_read();
  printf("read %d words\n",n);
  printf("  Full offset  Empty offset\n");
  printf("     %02x%02x%02x%02x  %02x%02x%02x%02x\n",rbuf[22]&0xFF,rbuf[23]&0xFF,rbuf[24]&0xFF,rbuf[25]&0xFF,rbuf[26]&0xFF,rbuf[27]&0xFF,rbuf[28]&0xFF,rbuf[29]&0xFF);
  full_off = 0;
  mt_off = 0;
  full_off = full_off | ((rbuf[22]&0xff)<<24)|((rbuf[23]&0xff)<<16)|((rbuf[24]&0xff)<<8)|(rbuf[25]&0xff);
  mt_off = mt_off | ((rbuf[26]&0xff)<<24)|((rbuf[27]&0xff)<<16)|((rbuf[28]&0xff)<<8)|(rbuf[29]&0xff);
  printf("full offset  = %d\n",full_off);
  printf("empty offset = %d\n",mt_off);
}

void ld_usr_reg(int user)
{
  int n;
  wbuf[0]=0x00;
  wbuf[1]=Load_User_Reg;
  wbuf[2]=(user>>24)&0xFF;
  wbuf[3]=(user>>16)&0xFF;
  wbuf[4]=(user>>8)&0xFF;
  wbuf[5]=user&0xFF;
  nwbuf=6;
  n=eth_write();
  return;
}
